diff -uNrd -x CVS ircd-hybrid-7rc5/src/ircd_parser.y ircd-hybrid-7-bg/src/ircd_parser.y
--- ircd-hybrid-7rc5/src/ircd_parser.y	Wed Oct 30 12:44:56 2002
+++ ircd-hybrid-7-bg/src/ircd_parser.y	Sat May 24 23:27:11 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: ircd_parser.y,v 1.261 2002/10/30 17:44:56 wiz Exp $
+ *  $Id: ircd_parser.y,v 1.8 2003/05/24 00:07:46 demond Exp $
  */
 
 %{
@@ -47,12 +47,6 @@
 #include "listener.h"
 #include "resv.h"
 
-#ifdef HAVE_LIBCRYPTO
-#include <openssl/rsa.h>
-#include <openssl/bio.h>
-#include <openssl/pem.h>
-#endif
-
 extern char *ip_string;
 
 int yyparse();
@@ -110,6 +104,8 @@
 %token  COMPRESSION_LEVEL
 %token  CONNECT
 %token  CONNECTFREQ
+%token  CYRILLIC
+%token  TOTALTRANS
 %token  CRYPTLINK
 %token  DEFAULT_CIPHER_PREFERENCE
 %token  DEFAULT_FLOODCOUNT
@@ -135,6 +131,7 @@
 %token  FNAME_FOPERLOG
 %token  FNAME_OPERLOG
 %token  FNAME_USERLOG
+%token  NETID
 %token  GECOS
 %token  GENERAL
 %token  GLINE
@@ -148,6 +145,8 @@
 %token  HIDDEN
 %token  HIDE_SERVERS
 %token  HOST
+%token  MASKHOST
+%token  SKIP_ON_FAIL
 %token  HUB
 %token  HUB_MASK
 %token  IAUTH_PORT
@@ -203,6 +202,7 @@
 %token  PING_COOKIE
 %token  PING_TIME
 %token  PORT
+%token  SSLPORT
 %token  QSTRING
 %token  QUIET_ON_BAN
 %token  REASON
@@ -213,12 +213,14 @@
 %token  RESTRICTED
 %token  RSA_PRIVATE_KEY_FILE
 %token  RSA_PUBLIC_KEY_FILE
+%token  SSL_CERTIFICATE_FILE
 %token	RESV
 %token  SECONDS MINUTES HOURS DAYS WEEKS MONTHS YEARS DECADES CENTURIES MILLENNIA
 %token  SENDQ
 %token  SEND_PASSWORD
 %token  SERVERHIDE
 %token  SERVERINFO
+%token  SERVICES
 %token  SERVLINK_PATH
 %token  T_SHARED
 %token  SHORT_MOTD
@@ -259,6 +261,7 @@
 %token  T_MAX_BUFFER
 %token  T_MAX_CLIENTS
 %token  T_NCHANGE
+%token	T_REMOTE
 %token  T_OPERWALL
 %token  T_REJ
 %token  T_SERVNOTICE
@@ -276,13 +279,38 @@
 %token  USE_HALFOPS
 %token  USE_HELP
 %token  USE_INVEX
+%token  USE_SUBST
+%token	USE_DENIES
 %token  USE_KNOCK
 %token  USE_VCHANS
 %token  VCHANS_OPER_ONLY
+%token	GRACE_TIME
 %token  VHOST
 %token  VHOST6
 %token  WARN
 %token  WARN_NO_NLINE
+%token  EQUIVALENT
+%token  NICKS
+%token  RELAYS
+%token	USERPAR
+%token	PARAM
+%token  DUMMY
+%token	DRONE_RATE_MAX
+%token	DRONE_RATE_PERIOD
+%token	DRONE_KLINE
+%token	DRONE_BATCH
+%token	DRONE_KLINE_TIME
+%token	DREASON
+%token	SPAM_WAIT
+%token	REPEAT_GRACE
+%token	SPAWN_PASS
+%token	GATEWAY
+%token	CLUSTERS
+%token	BRIDGE
+
+%left '-' '+'
+%left '*' '/'
+%left NEG
 
 %type   <string>   QSTRING
 %type   <number>   NUMBER
@@ -290,6 +318,7 @@
 %type	<number>   timespec_
 %type   <number>   sizespec
 %type   <number>   sizespec_
+%type   <number>   expr
 
 %%
 conf:   
@@ -299,26 +328,30 @@
 conf_item:        admin_entry
                 | logging_entry
                 | oper_entry
-		| channel_entry
+				| channel_entry
                 | class_entry 
                 | listen_entry
                 | auth_entry
                 | serverinfo_entry
-		| serverhide_entry
+				| serverhide_entry
                 | resv_entry
                 | shared_entry
                 | connect_entry
                 | kill_entry
                 | deny_entry
-		| exempt_entry
-		| general_entry
+				| exempt_entry
+				| general_entry
                 | gecos_entry
                 | modules_entry
+                | services_entry
+                | equivalent_entry
+                | relays_entry
+                | userpar_entry
+                | clusters_entry
                 | error ';'
                 | error '}'
         ;
 
-
 timespec_: { $$ = 0; } | timespec;
 timespec:	NUMBER timespec_
 		{
@@ -353,6 +386,36 @@
 		| NUMBER MBYTES sizespec_ { $$ = $1 * 1024 * 1024 + $3; }
 		;
 
+/* this is an arithmatic expression */
+expr:		NUMBER
+		{ 
+			$$ = $1;
+		}
+		| expr '+' expr
+		{ 
+			$$ = $1 + $3;
+		}
+		| expr '-' expr
+		{ 
+			$$ = $1 - $3;
+		}
+		| expr '*' expr
+		{ 
+			$$ = $1 * $3;
+		}
+		| expr '/' expr
+		{ 
+			$$ = $1 / $3;
+		}
+		| '-' expr  %prec NEG
+		{
+			$$ = -$2;
+		}
+		| '(' expr ')'
+		{
+			$$ = $2;
+		}
+		;
 
 /***************************************************************************
  *  section modules
@@ -407,8 +470,9 @@
 serverinfo_item:        serverinfo_name | serverinfo_vhost |
                         serverinfo_hub | serverinfo_description |
                         serverinfo_network_name | serverinfo_network_desc |
-                        serverinfo_max_clients | 
+                        serverinfo_max_clients | serverinfo_gateway |
                         serverinfo_rsa_private_key_file | serverinfo_vhost6 |
+                        serverinfo_ssl_certificate_file |
                         serverinfo_max_buffer | 
 			error;
 
@@ -470,6 +534,50 @@
 #endif
   };
 
+serverinfo_ssl_certificate_file: SSL_CERTIFICATE_FILE '=' QSTRING ';'
+  {
+#ifdef HAVE_LIBCRYPTO
+	if (ServerInfo.ctx) {
+	
+  		if (ServerInfo.ssl_certificate_file)
+  		{
+    		MyFree(ServerInfo.ssl_certificate_file);
+    		ServerInfo.ssl_certificate_file = NULL;
+  		}
+
+  		DupString(ServerInfo.ssl_certificate_file, yylval.string);
+
+		if (!ServerInfo.rsa_private_key_file) {
+			sendto_realops_flags(FLAGS_ALL, L_ALL,
+				"Ignoring config file entry ssl_certificate -- no rsa_private_key");
+			break;
+		}
+		
+		if (SSL_CTX_use_certificate_file(ServerInfo.ctx, 
+			ServerInfo.ssl_certificate_file, SSL_FILETYPE_PEM) <= 0) {
+			sendto_realops_flags(FLAGS_ALL, L_ALL,
+				"Error using config file entry ssl_certificate -- %s",
+				ERR_error_string(ERR_get_error(), NULL));
+			break;
+		}
+
+		if (SSL_CTX_use_PrivateKey_file(ServerInfo.ctx, 
+			ServerInfo.rsa_private_key_file, SSL_FILETYPE_PEM) <= 0) {
+			sendto_realops_flags(FLAGS_ALL, L_ALL,
+				"Error using config file entry rsa_private_key -- %s",
+				ERR_error_string(ERR_get_error(), NULL));
+			break;
+		}
+		
+		if (!SSL_CTX_check_private_key(ServerInfo.ctx)) {
+			sendto_realops_flags(FLAGS_ALL, L_ALL,
+				"RSA private key doesn't match the SSL certificate public key!");
+			break;
+		}
+	}
+#endif
+  };
+  
 serverinfo_name:        NAME '=' QSTRING ';' 
   {
     /* this isn't rehashable */
@@ -542,6 +650,16 @@
     ServerInfo.max_buffer = $3;
   };
 
+serverinfo_gateway: GATEWAY '=' TYES ';'
+   {
+     ServerInfo.gateway = 1;
+   }
+     |
+     GATEWAY '=' TNO ';'
+   {
+     ServerInfo.gateway = 0;
+   } ;
+
 serverinfo_hub:         HUB '=' TYES ';' 
   {
     /* Don't become a hub if we have a lazylink active. */
@@ -951,8 +1069,109 @@
     class_sendq_var = $3;
   };
 
+/***************************************************************************
+ *  section equivalent, defines equivalent nicks          -demond
+ ***************************************************************************/
+
+equivalent_entry:   EQUIVALENT
+  {
+  }
+  '{' equivalent_items '}' ';'
+  {
+  };
+
+equivalent_items:   equivalent_items equivalent_item |
+                    equivalent_item
+;
+equivalent_item:    equivalent_nicks | equivalent_dummy | error
+;
+equivalent_nicks:   NICKS '=' QSTRING ';'
+  {
+    add_equiv_nicks(yylval.string);
+  };
+
+equivalent_dummy:   DUMMY '=' expr ';'
+  {
+  };
 
 /***************************************************************************
+ *  section relays, defines relay pseudo servers          -demond
+ ***************************************************************************/
+
+relays_entry:       RELAYS
+  {
+  }
+  '{' relays_items '}' ';'
+  {
+  };
+
+relays_items:       relays_items relays_item |
+                    relays_item
+;
+relays_item:        relay_server | relay_dummy | error
+;
+relay_server:       NAME '=' QSTRING ';'
+  {
+    add_relay_server(yylval.string);
+  };
+
+relay_dummy:        DUMMY '=' expr ';'
+  {
+  };
+
+/***************************************************************************
+ *  section userpar, defines USER constant parameters 
+ *  by various clients, mostly Java applets                    -demond
+ ***************************************************************************/
+
+userpar_entry:      USERPAR
+  {
+  }
+  '{' userpar_items '}' ';'
+  {
+  };
+
+userpar_items:      userpar_items userpar_item |
+                    userpar_item
+;
+userpar_item:       userpar_param | userpar_dummy | error
+;
+userpar_param:      PARAM '=' QSTRING ';'
+  {
+    add_userpar_param(yylval.string);
+  };
+
+userpar_dummy:      DUMMY '=' expr ';'
+  {
+  };
+ 
+/***************************************************************************
+ *  section clusters, defines foreign cluster gateways
+ *  whose nicks we prepend with tokens                       -demond
+ ***************************************************************************/
+
+clusters_entry:      CLUSTERS
+  {
+  }
+  '{' clusters_items '}' ';'
+  {
+  };
+
+clusters_items:      clusters_items clusters_item |
+                     clusters_item
+;
+clusters_item:       cluster_bridge | cluster_dummy | error
+;
+cluster_bridge:      BRIDGE '=' QSTRING ';'
+  {
+    add_cluster_bridge(yylval.string);
+  };
+
+cluster_dummy:       DUMMY '=' expr ';'
+  {
+  };
+ 
+/***************************************************************************
  *  section listen
  ***************************************************************************/
 
@@ -969,7 +1188,8 @@
 listen_items:   listen_items listen_item |
                 listen_item;
 
-listen_item:    listen_port | listen_address | listen_host | error;
+listen_item:    listen_port | listen_sslport |
+				listen_address | listen_host | error;
 
 listen_port: PORT '=' port_items ';' ;
 
@@ -977,13 +1197,29 @@
 
 port_item: NUMBER
 {
-  add_listener($1, listener_address);
+  add_listener($1, listener_address, 0);
 } | NUMBER TWODOTS NUMBER
 {
   int i;
   for (i = $1; i <= $3; i++)
 	{
-	  add_listener(i, listener_address);
+	  add_listener(i, listener_address, 0);
+	}
+};
+
+listen_sslport: SSLPORT '=' sslport_items ';' ;
+
+sslport_items: sslport_items ',' sslport_item | sslport_item;
+
+sslport_item: NUMBER
+{
+  add_listener($1, listener_address, 1);
+} | NUMBER TWODOTS NUMBER
+{
+  int i;
+  for (i = $1; i <= $3; i++)
+	{
+	  add_listener(i, listener_address, 1);
 	}
 };
 
@@ -1077,7 +1313,7 @@
                 auth_exceed_limit | auth_no_tilde | auth_gline_exempt |
                 auth_spoof | auth_spoof_notice |
                 auth_redir_serv | auth_redir_port | auth_can_flood |
-                error;
+                auth_maskhost | auth_skipfail | error;
 
 auth_user:   USER '=' QSTRING ';'
   {
@@ -1234,6 +1470,24 @@
     DupString(yy_achead->className, yylval.string);
   };
 
+auth_maskhost: MASKHOST '=' TYES ';'
+  {
+   yy_achead->flags |= CONF_FLAGS_MASKHOST;
+  }
+  |            MASKHOST '=' TNO ';'
+  {
+   yy_achead->flags &= CONF_FLAGS_MASKHOST;
+  };
+
+auth_skipfail: SKIP_ON_FAIL '=' TYES ';'
+  {
+   yy_achead->flags |= CONF_FLAGS_SKIPFAIL;
+  }
+  |            SKIP_ON_FAIL '=' TNO ';'
+  {
+   yy_achead->flags &= CONF_FLAGS_SKIPFAIL;
+  };
+
 
 /***************************************************************************
  *  section resv
@@ -1342,6 +1596,53 @@
   };
 
 /***************************************************************************
+ *  section services, for defining which servers
+ *  are to be treated specially (as services)       -demond 
+ ***************************************************************************/
+
+services_entry:		SERVICES
+  {
+    if(yy_aconf != NULL)
+      {
+        free_conf(yy_aconf);
+        yy_aconf = NULL;
+      }
+    yy_aconf=make_conf();
+    yy_aconf->status = CONF_ZLINE;
+    yy_aconf->name = NULL;
+    yy_aconf->user = NULL;
+    yy_aconf->host = NULL;
+  }
+  '{' services_items '}' ';'
+  {
+    conf_add_z_conf(yy_aconf);
+    yy_aconf = (struct ConfItem *)NULL;
+  };
+
+services_items:		services_items services_item |
+			services_item
+;
+services_item:		services_name | services_user | services_host | error
+;
+services_name:		NAME '=' QSTRING ';'
+  {
+    MyFree(yy_aconf->name);
+    DupString(yy_aconf->name, yylval.string);
+  };
+
+services_user:		USER '=' QSTRING ';'
+  {
+    MyFree(yy_aconf->user);
+    DupString(yy_aconf->user, yylval.string);
+  };
+
+services_host:		HOST '=' QSTRING ';'
+  {
+    MyFree(yy_aconf->host);
+    DupString(yy_aconf->host, yylval.string);
+  };
+
+/***************************************************************************
  *  section connect
  ***************************************************************************/
 
@@ -1948,6 +2249,7 @@
                     general_max_nick_changes | general_max_accept |
                     general_anti_spam_exit_message_time |
                     general_ts_warn_delta | general_ts_max_delta |
+					general_grace_time | general_spam_wait |
                     general_kline_with_reason |
                     general_kline_with_connection_closed |
                     general_warn_no_nline |
@@ -1960,12 +2262,12 @@
                     general_iauth_server |
                     general_iauth_port |
                     general_glines | general_gline_time |
-                    general_idletime |
+                    general_idletime | general_spawn_pass |
                     general_maximum_links |
                     general_message_locale | general_client_exit |
                     general_fname_userlog | general_fname_operlog |
                     general_fname_foperlog | general_oper_only_umodes |
-                    general_max_targets |
+                    general_max_targets | general_repeat_grace |
                     general_use_egd | general_egdpool_path |
                     general_oper_umodes |
                     general_caller_id_wait | general_default_floodcount |
@@ -1976,8 +2278,32 @@
                     general_throttle_time | general_havent_read_conf |
                     general_dot_in_ip6_addr | general_ping_cookie |
                     general_fallback_to_ip6_int | 
+                    general_netid | general_cyrillic | general_totaltrans |
+					general_drate_max | general_drate_period |
+					general_drone_kline | general_drone_batch |
+					general_drone_ktime | general_drone_reason |
                     error;
 
+general_cyrillic: CYRILLIC '=' TNO ';'
+  {
+    ConfigFileEntry.cyrillic = 0;
+  }
+    |
+    CYRILLIC '=' TYES ';'
+  {
+    ConfigFileEntry.cyrillic = 1;
+  } ;  
+
+general_totaltrans: TOTALTRANS '=' TNO ';'
+  {
+    ConfigFileEntry.totaltrans = 0;
+  }
+    |
+    TOTALTRANS '=' TYES ';'
+  {
+    ConfigFileEntry.totaltrans = 1;
+  } ;  
+
 general_failed_oper_notice:   FAILED_OPER_NOTICE '=' TYES ';'
   {
     ConfigFileEntry.failed_oper_notice = 1;
@@ -2038,6 +2364,57 @@
     exit(0);
   }
 };
+
+general_grace_time:    GRACE_TIME '=' timespec ';'
+  {
+    ConfigFileEntry.grace_time = $3;
+  } ;
+
+general_spam_wait:     SPAM_WAIT '=' timespec ';'
+  {
+    ConfigFileEntry.spam_wait = $3;
+  } ;
+
+general_repeat_grace:  REPEAT_GRACE '=' timespec ';'
+  {
+    ConfigFileEntry.repeat_grace = $3;
+  } ;
+
+general_drate_max:     DRONE_RATE_MAX '=' NUMBER ';'
+  {
+    ConfigFileEntry.drone_rate_max = $3;
+  } ;
+
+general_drate_period:  DRONE_RATE_PERIOD '=' timespec ';'
+  {
+    ConfigFileEntry.drone_rate_period = $3;
+  } ;
+
+general_drone_ktime:   DRONE_KLINE_TIME '=' timespec ';'
+  {
+    ConfigFileEntry.drone_kline_time = $3;
+  } ;
+
+general_drone_kline:   DRONE_KLINE '=' TYES ';'
+  {
+    ConfigFileEntry.drone_kline = 1;
+  }
+    |
+    DRONE_KLINE '=' TNO ';'
+  {
+    ConfigFileEntry.drone_kline = 0;
+  } ;
+
+general_drone_batch:   DRONE_BATCH '=' TYES ';'
+  {
+    ConfigFileEntry.drone_batch = 1;
+  }
+    |
+    DRONE_BATCH '=' TNO ';'
+  {
+    ConfigFileEntry.drone_batch = 0;
+  } ;
+
 general_kline_with_reason: KLINE_WITH_REASON '=' TYES ';'
   {
     ConfigFileEntry.kline_with_reason = 1;
@@ -2215,6 +2592,24 @@
 	      MAXPATHLEN);
 };
 
+general_netid: NETID '=' QSTRING ';'
+{
+  strncpy(ConfigFileEntry.netid, yylval.string,
+	      MAXNETID)[MAXNETID] = 0;
+};
+
+general_spawn_pass: SPAWN_PASS '=' QSTRING ';'
+{
+  strncpy(ConfigFileEntry.spawn_pass, yylval.string,
+	      PASSWDLEN)[PASSWDLEN] = 0;
+};
+
+general_drone_reason: DREASON '=' QSTRING ';'
+{
+  strncpy(ConfigFileEntry.drone_reason, yylval.string,
+	      MAXDREASON)[MAXDREASON] = 0;
+};
+
 general_glines: GLINES '=' TYES ';'
   {
     ConfigFileEntry.glines = 1;
@@ -2227,11 +2622,20 @@
 
 general_message_locale: MESSAGE_LOCALE '=' QSTRING ';'
   {
-    char langenv[BUFSIZE];
+    static char langenv[BUFSIZE];
+    static char langenv2[BUFSIZE];
     if (strlen(yylval.string) > BUFSIZE-10)
       yylval.string[BUFSIZE-9] = 0;
     ircsprintf(langenv, "LANGUAGE=%s", yylval.string);
     putenv(langenv);
+    ircsprintf(langenv2, "LC_MESSAGES=%s", yylval.string);
+    putenv(langenv2);
+#ifdef USE_GETTEXT
+	{
+	  extern int  _nl_msg_cat_cntr;
+	  ++_nl_msg_cat_cntr;
+	}
+#endif
   } ;
 
 general_gline_time: GLINE_TIME '=' timespec ';'
@@ -2405,6 +2809,10 @@
   {
     ConfigFileEntry.oper_umodes |= FLAGS_NCHANGE;
   }
+              | T_REMOTE
+  {
+    ConfigFileEntry.oper_umodes |= FLAGS_REMOTE;
+  }
               | T_REJ
   {
     ConfigFileEntry.oper_umodes |= FLAGS_REJ;
@@ -2479,6 +2887,10 @@
   {
     ConfigFileEntry.oper_only_umodes |= FLAGS_NCHANGE;
   }
+              | T_REMOTE
+  {
+    ConfigFileEntry.oper_only_umodes |= FLAGS_REMOTE;
+  }
               | T_REJ
   {
     ConfigFileEntry.oper_only_umodes |= FLAGS_REJ;
@@ -2556,20 +2968,22 @@
 channel_item:       channel_use_except |
                     channel_use_halfops |
                     channel_use_invex |
+                    channel_use_subst |
+                    channel_use_denies |
                     channel_use_knock |
                     channel_use_vchans |
-		    channel_use_anonops |
-		    channel_vchans_oper_only |
+		    		channel_use_anonops |
+		    		channel_vchans_oper_only |
                     channel_max_bans |
                     channel_knock_delay |
-		    channel_knock_delay_channel |
+		    		channel_knock_delay_channel |
                     channel_max_chans_per_user |
                     channel_quiet_on_ban |
-		    channel_default_split_user_count | 
-		    channel_default_split_server_count |
-		    channel_no_create_on_split | 
-		    channel_no_join_on_split |
-		    channel_oper_pass_resv |
+		    		channel_default_split_user_count | 
+		    		channel_default_split_server_count |
+		    		channel_no_create_on_split | 
+		    		channel_no_join_on_split |
+		    		channel_oper_pass_resv |
                     error;
 
 channel_use_except:   USE_EXCEPT '=' TYES ';'
@@ -2647,6 +3061,28 @@
                      USE_INVEX '=' TNO ';'
   {
     ConfigChannel.use_invex = 0;
+  } ;
+
+
+channel_use_subst:   USE_SUBST '=' TYES ';'
+  {
+    ConfigChannel.use_subst = 1;
+  }
+                        |
+                     USE_SUBST '=' TNO ';'
+  {
+    ConfigChannel.use_subst = 0;
+  } ;
+
+
+channel_use_denies:   USE_DENIES '=' TYES ';'
+  {
+    ConfigChannel.use_denies = 1;
+  }
+                        |
+                     USE_DENIES '=' TNO ';'
+  {
+    ConfigChannel.use_denies = 0;
   } ;
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/ircd_signal.c ircd-hybrid-7-bg/src/ircd_signal.c
--- ircd-hybrid-7rc5/src/ircd_signal.c	Tue Jun 25 23:05:45 2002
+++ ircd-hybrid-7-bg/src/ircd_signal.c	Sun Mar  2 15:08:22 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd_signal.c,v 7.12 2002/06/26 03:05:45 androsyn Exp $
+ * $Id: ircd_signal.c,v 1.2 2003/03/02 20:08:22 demond Exp $
  */
 
 #include "stdinc.h"
@@ -84,6 +84,13 @@
     }
 }
 
+static void sigchld_handler(int sig)
+{
+	int status;
+
+	waitpid(-1, &status, WNOHANG);
+}
+
 /*
  * setup_signals - initialize signal handlers for server
  */
@@ -122,6 +129,9 @@
   sigaddset(&act.sa_mask, SIGTERM);
   sigaction(SIGTERM, &act, 0);
 
+  act.sa_handler = sigchld_handler;
+  sigaddset(&act.sa_mask, SIGCHLD);
+  sigaction(SIGCHLD, &act, 0);
 }
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/ircdauth.c ircd-hybrid-7-bg/src/ircdauth.c
--- ircd-hybrid-7rc5/src/ircdauth.c	Thu Aug 15 10:15:36 2002
+++ ircd-hybrid-7-bg/src/ircdauth.c	Mon Mar 10 01:09:05 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: ircdauth.c,v 7.49 2002/08/15 14:15:36 db Exp $
+ *  $Id: ircdauth.c,v 1.2 2003/03/10 06:09:05 demond Exp $
  */
 
 #include "stdinc.h"
@@ -625,13 +625,13 @@
   if (++Count.total > Count.max_tot)
     Count.max_tot = Count.total;
   
-  sendto_one(client, form_str(RPL_WELCOME),
+  sendto_one(client, form_str(client,RPL_WELCOME),
 	     me.name,
 	     client->name,
 	     client->name);
 
   /* This is a duplicate of the NOTICE but see below...*/
-  sendto_one(client, form_str(RPL_YOURHOST),
+  sendto_one(client, form_str(client,RPL_YOURHOST),
 	     me.name,
 	     client->name,
 	     get_listener_name(client->localClient->listener), version);
@@ -645,12 +645,12 @@
 	     get_listener_name(client->localClient->listener),
 	     version);
 
-  sendto_one(client, form_str(RPL_CREATED),
+  sendto_one(client, form_str(client,RPL_CREATED),
 	     me.name,
 	     client->name,
 	     creation);
 
-  sendto_one(client, form_str(RPL_MYINFO),
+  sendto_one(client, form_str(client,RPL_MYINFO),
 	     me.name,
 	     client->name,
 	     me.name,
@@ -667,18 +667,18 @@
 	       "NOTICE %s :*** Notice -- Please read the motd if you haven't read it",
 	       client->name);
 
-    sendto_one(client, form_str(RPL_MOTDSTART),
+    sendto_one(client, form_str(client,RPL_MOTDSTART),
 	       me.name,
 	       client->name,
 	       me.name);
 
     sendto_one(client,
-	       form_str(RPL_MOTD),
+	       form_str(client,RPL_MOTD),
 	       me.name,
 	       client->name,
 	       "*** This is the short motd ***");
     
-    sendto_one(client, form_str(RPL_ENDOFMOTD),
+    sendto_one(client, form_str(client,RPL_ENDOFMOTD),
 	       me.name,
 	       client->name);
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/kdparse.c ircd-hybrid-7-bg/src/kdparse.c
--- ircd-hybrid-7rc5/src/kdparse.c	Sat Jul  6 12:58:57 2002
+++ ircd-hybrid-7-bg/src/kdparse.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: kdparse.c,v 7.8 2002/07/06 16:58:57 db Exp $
+ *  $Id: kdparse.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/linebuf.c ircd-hybrid-7-bg/src/linebuf.c
--- ircd-hybrid-7rc5/src/linebuf.c	Wed Oct  9 11:08:32 2002
+++ ircd-hybrid-7-bg/src/linebuf.c	Tue Feb  4 11:13:06 2003
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: linebuf.c,v 7.93 2002/10/09 15:08:32 db Exp $
+ *  $Id: linebuf.c,v 1.4 2003/02/04 16:13:06 demond Exp $
  */
 
 #include "stdinc.h"
@@ -32,6 +32,8 @@
 #include "list.h"
 #include "balloc.h"
 #include "hook.h"
+#include "fdlist.h"
+#include "send.h"
 
 #ifdef STRING_WITH_STRINGS
 # include <string.h>
@@ -634,6 +636,9 @@
 {
   buf_line_t *bufline;
   int retval;
+#ifdef HAVE_LIBCRYPTO
+  fde_t *F = (fd > -1)? &fd_table[fd] : NULL;
+#endif
   
   /* Check we actually have a first buffer */
   if (bufhead->list.head == NULL)
@@ -660,6 +665,86 @@
     }
 
   /* Now, try writing data */
+#ifdef HAVE_LIBCRYPTO
+  if (F && F->ssl) {
+  	/*extern time_t CurrentTime;*/
+  	extern char *get_ssl_error(int);
+  	/*static*/ int alerted = 0;
+  
+  	if (F->flags.accept_write) {
+  		int ret;
+  		/*send(fd, bufline->buf + bufhead->writeofs, bufline->len
+  			- bufhead->writeofs, 0);*/
+  		if ((ret = SSL_accept(F->ssl)) > 0) {
+  			if (!alerted)
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL, 
+  				"SSL_accept() for %s (socket %d) wanting WRITE succeeded!",
+  				inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd);
+  			F->flags.accept_write = 0;
+  		} else if (F->accept_failures < 4) {
+  			int val = SSL_get_error(F->ssl, ret);  		
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL, 
+  				"SSL_accept() for %s (socket %d) wanting WRITE error! -- %s",
+  				inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd,
+  				(val == SSL_ERROR_SSL)?
+  				ERR_error_string(ERR_get_error(), NULL) :
+  				get_ssl_error(val));
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL,
+  				"BIO_sock_should_retry(): %d", BIO_sock_should_retry(ret));
+  		if (val == SSL_ERROR_SYSCALL) {
+  			int err = ERR_get_error();
+  			if (err)
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "ERR_get_error() -- %s",
+  					ERR_error_string(err, NULL));
+  			else
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "more error info -- %s",
+  					(ret == -1)? strerror(errno) : "got EOF, protocol violation");  
+  		}
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_state_string_long(): %s",
+  				SSL_state_string_long(F->ssl));
+  			F->accept_failures++;
+  		}
+  		retval = -1; errno = EAGAIN;
+  	} else {
+
+#if 0  				
+  	/*if (CurrentTime % 10 == 0)*/
+  	if (!alerted) {
+  	sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_write() for %s (socket %d) in progress...",
+  		inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd);
+  	sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_state_string_long(): %s",
+  		SSL_state_string_long(F->ssl));
+  	}
+#endif
+  		
+  	retval = SSL_write(F->ssl, bufline->buf + bufhead->writeofs, 
+  				bufline->len - bufhead->writeofs);
+  				
+  	if (retval <= 0 && !alerted) {
+  		int val = SSL_get_error(F->ssl, retval);
+  		/*if (CurrentTime % 10 == 0)*/
+  		sendto_realops_flags(FLAGS_DEBUG, L_ALL, 
+  			"SSL_write() for %s (socket %d) ERROR! -- %s",
+  			inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd,
+  			(val == SSL_ERROR_SSL)?
+  			ERR_error_string(ERR_get_error(), NULL) :
+  			get_ssl_error(val));
+  		if (val == SSL_ERROR_SYSCALL) {
+  			int err = ERR_get_error();
+  			if (err)
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "ERR_get_error() -- %s",
+  					ERR_error_string(err, NULL));
+  			else
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "more error info -- %s",
+  					(retval == -1)? strerror(errno) : "got EOF, protocol violation");  
+  		} else {
+  			/*SSL_set_accept_state(F->ssl);*/
+  			errno = EAGAIN;
+  		}
+  	}}
+  	alerted = 1;
+  } else
+#endif
   retval = send(fd, bufline->buf + bufhead->writeofs, bufline->len
 		 - bufhead->writeofs, 0);
    
diff -uNrd -x CVS ircd-hybrid-7rc5/src/list.c ircd-hybrid-7-bg/src/list.c
--- ircd-hybrid-7rc5/src/list.c	Wed Oct 23 18:12:14 2002
+++ ircd-hybrid-7-bg/src/list.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: list.c,v 7.47 2002/10/23 22:12:14 bill Exp $
+ *  $Id: list.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/listener.c ircd-hybrid-7-bg/src/listener.c
--- ircd-hybrid-7rc5/src/listener.c	Thu Jul 11 20:51:08 2002
+++ ircd-hybrid-7-bg/src/listener.c	Mon Mar 10 01:09:05 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: listener.c,v 7.70 2002/07/12 00:51:08 androsyn Exp $
+ *  $Id: listener.c,v 1.4 2003/03/10 06:09:05 demond Exp $
  */
 
 #include "stdinc.h"
@@ -127,10 +127,10 @@
 
   for (listener = ListenerPollList; listener; listener = listener->next)
   {
-    sendto_one(source_p, form_str(RPL_STATSPLINE),
+    sendto_one(source_p, form_str(source_p,RPL_STATSPLINE),
                me.name,
                source_p->name,
-               'P',
+               listener->is_ssl? 'S' : 'P',
                listener->port,
                IsOperAdmin(source_p) ? listener->name : me.name,
                listener->ref_count,
@@ -271,7 +271,7 @@
  * the format "255.255.255.255"
  */
 void 
-add_listener(int port, const char* vhost_ip)
+add_listener(int port, const char* vhost_ip, int is_ssl)
 {
   struct Listener* listener;
   struct irc_inaddr   vaddr;
@@ -304,6 +304,8 @@
     listener = make_listener(port, &vaddr);
     listener->next = ListenerPollList;
     ListenerPollList = listener;
+    
+    listener->is_ssl = is_ssl;
   }
 
   listener->fd = -1;
@@ -384,7 +386,7 @@
    * be accepted until some old is closed first.
    */
 
-  fd = comm_accept(listener->fd, &sai);
+  fd = comm_accept(listener->fd, &sai, listener->is_ssl);
 
   copy_s_addr(IN_ADDR(addr), S_ADDR(sai));
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/m_error.c ircd-hybrid-7-bg/src/m_error.c
--- ircd-hybrid-7rc5/src/m_error.c	Wed Oct 23 21:16:37 2002
+++ ircd-hybrid-7-bg/src/m_error.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_error.c,v 7.26 2002/10/24 01:16:37 bill Exp $
+ *  $Id: m_error.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/match.c ircd-hybrid-7-bg/src/match.c
--- ircd-hybrid-7rc5/src/match.c	Wed Aug 28 13:00:14 2002
+++ ircd-hybrid-7-bg/src/match.c	Sat May 24 23:27:11 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: match.c,v 7.21 2002/08/28 17:00:14 androsyn Exp $
+ * $Id: match.c,v 1.2 2003/05/24 00:07:47 demond Exp $
  *
  */
 #include "stdinc.h"
@@ -413,10 +413,10 @@
   0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
   0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
   0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
-  0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
-  0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
-  0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
-  0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
+  0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
+  0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
+  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
+  0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff,
   0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
   0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
   0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
@@ -452,10 +452,10 @@
   0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
   0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
   0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
-  0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
-  0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
-  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
-  0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff 
+  0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
+  0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
+  0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
+  0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf 
 };
 
 /*
@@ -498,7 +498,7 @@
 /* 30 */     CNTRL_C|CHAN_C|NONEOS_C,
 /* 31 */     CNTRL_C|CHAN_C|NONEOS_C,
 /* SP */     PRINT_C|SPACE_C,
-/* ! */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C,
+/* ! */      PRINT_C|KWILD_C|NICK_C|CHAN_C|NONEOS_C,
 /* " */      PRINT_C|CHAN_C|NONEOS_C,
 /* # */      PRINT_C|CHANPFX_C|CHAN_C|NONEOS_C,
 /* $ */      PRINT_C|CHAN_C|NONEOS_C|USER_C,
diff -uNrd -x CVS ircd-hybrid-7rc5/src/md5.c ircd-hybrid-7-bg/src/md5.c
--- ircd-hybrid-7rc5/src/md5.c	Fri May 24 21:35:09 2002
+++ ircd-hybrid-7-bg/src/md5.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: md5.c,v 1.14 2002/05/25 01:35:09 androsyn Exp $
+ *  $Id: md5.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
